Index: serefpolicy-contrib-20140730/wine.if
===================================================================
--- serefpolicy-contrib-20140730.orig/wine.if
+++ serefpolicy-contrib-20140730/wine.if
@@ -1,46 +1,57 @@
-## <summary>Run Windows programs in Linux.</summary>
+## <summary>Wine Is Not an Emulator.  Run Windows programs in Linux.</summary>
 
-########################################
+#######################################
 ## <summary>
-##	Role access for wine.
+##	The per role template for the wine module.
 ## </summary>
-## <param name="role">
+## <desc>
+##	<p>
+##	This template creates a derived domains which are used
+##	for wine applications.
+##	</p>
+## </desc>
+## <param name="user_role">
 ##	<summary>
-##	Role allowed access.
+##	The role associated with the user domain.
 ##	</summary>
 ## </param>
-## <param name="domain">
+## <param name="user_domain">
 ##	<summary>
-##	User domain for the role.
+##	The type of the user domain.
 ##	</summary>
 ## </param>
 #
-interface(`wine_role',`
+template(`wine_role',`
 	gen_require(`
-		attribute_role wine_roles;
-		type wine_exec_t, wine_t, wine_tmp_t;
+		type wine_t;
 		type wine_home_t;
+		type wine_exec_t;
 	')
 
-	roleattribute $1 wine_roles;
-
-	domtrans_pattern($2, wine_exec_t, wine_t)
+	role $1 types wine_t;
 
+	domain_auto_trans($2, wine_exec_t, wine_t)
+	# Unrestricted inheritance from the caller.
+	allow $2 wine_t:process { noatsecure siginh rlimitinh };
+	allow wine_t $2:fd use;
+	allow wine_t $2:process { sigchld signull };
 	allow wine_t $2:unix_stream_socket connectto;
-	allow wine_t $2:process signull;
 
+	# Allow the user domain to signal/ps.
 	ps_process_pattern($2, wine_t)
-	allow $2 wine_t:process { ptrace signal_perms };
+	allow $2 wine_t:process signal_perms;
 
 	allow $2 wine_t:fd use;
-	allow $2 wine_t:shm { associate getattr };
-	allow $2 wine_t:shm rw_shm_perms;
+	allow $2 wine_t:shm { associate getattr  unix_read unix_write };
 	allow $2 wine_t:unix_stream_socket connectto;
 
-	allow $2 { wine_tmp_t wine_home_t }:dir { manage_dir_perms relabel_dir_perms };
-	allow $2 { wine_tmp_t wine_home_t }:file { manage_file_perms relabel_file_perms };
-	allow $2 wine_home_t:lnk_file { manage_lnk_file_perms relabel_lnk_file_perms };
-	userdom_user_home_dir_filetrans($2, wine_home_t, dir, ".wine")
+	# X access, Home files
+	manage_dirs_pattern($2, wine_home_t, wine_home_t)
+	manage_files_pattern($2, wine_home_t, wine_home_t)
+	manage_lnk_files_pattern($2, wine_home_t, wine_home_t)
+	relabel_dirs_pattern($2, wine_home_t, wine_home_t)
+	relabel_files_pattern($2, wine_home_t, wine_home_t)
+	relabel_lnk_files_pattern($2, wine_home_t, wine_home_t)
 ')
 
 #######################################
@@ -72,31 +83,25 @@ interface(`wine_role',`
 #
 template(`wine_role_template',`
 	gen_require(`
+		type wine_t;
+		attribute wine_domain;
 		type wine_exec_t;
 	')
 
-	type $1_wine_t;
-	userdom_user_application_domain($1_wine_t, wine_exec_t)
+	type $1_wine_t, wine_domain;
+	domain_type($1_wine_t)
+	domain_entry_file($1_wine_t, wine_exec_t)
+	ubac_constrained($1_wine_t)
 	role $2 types $1_wine_t;
-
-	allow $1_wine_t self:process { execmem execstack };
-
-	allow $3 $1_wine_t:process { ptrace noatsecure signal_perms };
-	ps_process_pattern($3, $1_wine_t)
-
+	allow $3 $1_wine_t:process { getattr noatsecure signal_perms };
 	domtrans_pattern($3, wine_exec_t, $1_wine_t)
-
-	corecmd_bin_domtrans($1_wine_t, $3)
+	corecmd_bin_domtrans($1_wine_t, $1_t)
 
 	userdom_unpriv_usertype($1, $1_wine_t)
-	userdom_manage_user_tmpfs_files($1_wine_t)
+	userdom_manage_tmpfs_role($2, $1_wine_t)
 
 	domain_mmap_low($1_wine_t)
 
-	tunable_policy(`wine_mmap_zero_ignore',`
-		dontaudit $1_wine_t self:memprotect mmap_zero;
-	')
-
 	optional_policy(`
 		xserver_role($1_r, $1_wine_t)
 	')
@@ -123,9 +128,8 @@ interface(`wine_domtrans',`
 
 ########################################
 ## <summary>
-##	Execute wine in the wine domain,
-##	and allow the specified role
-##	the wine domain.
+##	Execute wine in the wine domain, and
+##	allow the specified role the wine domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -140,11 +144,11 @@ interface(`wine_domtrans',`
 #
 interface(`wine_run',`
 	gen_require(`
-		attribute_role wine_roles;
+		type wine_t;
 	')
 
 	wine_domtrans($1)
-	roleattribute $2 wine_roles;
+	role $2 types wine_t;
 ')
 
 ########################################
@@ -165,3 +169,22 @@ interface(`wine_rw_shm',`
 
 	allow $1 wine_t:shm rw_shm_perms;
 ')
+
+########################################
+## <summary>
+##	Transition to wine named content
+## </summary>
+## <param name="domain">
+##	<summary>
+##      Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`wine_filetrans_named_content',`
+	gen_require(`
+		type wine_home_t;
+	')
+
+	userdom_user_home_dir_filetrans($1, wine_home_t, dir, ".wine")
+')
+
Index: serefpolicy-contrib-20140730/wine.te
===================================================================
--- serefpolicy-contrib-20140730.orig/wine.te
+++ serefpolicy-contrib-20140730/wine.te
@@ -14,10 +14,11 @@ policy_module(wine, 1.11.0)
 ## </desc>
 gen_tunable(wine_mmap_zero_ignore, false)
 
+attribute wine_domain;
 attribute_role wine_roles;
 roleattribute system_r wine_roles;
 
-type wine_t;
+type wine_t, wine_domain;
 type wine_exec_t;
 userdom_user_application_domain(wine_t, wine_exec_t)
 role wine_roles types wine_t;
@@ -25,56 +26,58 @@ role wine_roles types wine_t;
 type wine_home_t;
 userdom_user_home_content(wine_home_t)
 
-type wine_tmp_t;
-userdom_user_tmp_file(wine_tmp_t)
-
 ########################################
 #
 # Local policy
 #
+domain_mmap_low(wine_t)
 
-allow wine_t self:process { execstack execmem execheap };
-allow wine_t self:fifo_file manage_fifo_file_perms;
+optional_policy(`
+	unconfined_domain(wine_t)
+')
 
-can_exec(wine_t, wine_exec_t)
 
-userdom_user_home_dir_filetrans(wine_t, wine_home_t, dir, ".wine")
+########################################
+#
+# Common wine domain policy
+#
 
-manage_dirs_pattern(wine_t, wine_tmp_t, wine_tmp_t)
-manage_files_pattern(wine_t, wine_tmp_t, wine_tmp_t)
-files_tmp_filetrans(wine_t, wine_tmp_t, { file dir })
+allow wine_domain self:process { execstack execmem execheap };
+allow wine_domain self:fifo_file manage_fifo_file_perms;
 
-domain_mmap_low(wine_t)
+can_exec(wine_domain, wine_exec_t)
+
+manage_files_pattern(wine_domain, wine_home_t, wine_home_t)
+manage_dirs_pattern(wine_domain, wine_home_t, wine_home_t)
+userdom_tmpfs_filetrans(wine_domain, file)
+wine_filetrans_named_content(wine_domain)
 
-files_execmod_all_files(wine_t)
+files_execmod_all_files(wine_domain)
 
-userdom_use_user_terminals(wine_t)
+userdom_use_inherited_user_terminals(wine_domain)
 
 tunable_policy(`wine_mmap_zero_ignore',`
-	dontaudit wine_t self:memprotect mmap_zero;
+	dontaudit wine_domain self:memprotect mmap_zero;
 ')
 
 optional_policy(`
-	dbus_system_bus_client(wine_t)
+	dbus_system_bus_client(wine_domain)
 
 	optional_policy(`
-		hal_dbus_chat(wine_t)
+		hal_dbus_chat(wine_domain)
 	')
 
 	optional_policy(`
-		policykit_dbus_chat(wine_t)
+		policykit_dbus_chat(wine_domain)
 	')
 ')
 
 optional_policy(`
-	rtkit_scheduled(wine_t)
+	rtkit_scheduled(wine_domain)
 ')
 
 optional_policy(`
-	unconfined_domain(wine_t)
+	xserver_read_xdm_pid(wine_domain)
+	xserver_rw_shm(wine_domain)
 ')
 
-optional_policy(`
-	xserver_read_xdm_pid(wine_t)
-	xserver_rw_shm(wine_t)
-')
Index: serefpolicy-contrib-20140730/wireshark.te
===================================================================
--- serefpolicy-contrib-20140730.orig/wireshark.te
+++ serefpolicy-contrib-20140730/wireshark.te
@@ -34,7 +34,7 @@ userdom_user_tmpfs_file(wireshark_tmpfs_
 # Local Policy
 #
 
-allow wireshark_t self:capability { net_admin net_raw setgid };
+allow wireshark_t self:capability { net_admin net_raw };
 allow wireshark_t self:process { signal getsched };
 allow wireshark_t self:fifo_file rw_fifo_file_perms;
 allow wireshark_t self:shm create_shm_perms;
@@ -82,7 +82,6 @@ dev_read_rand(wireshark_t)
 dev_read_sysfs(wireshark_t)
 dev_read_urand(wireshark_t)
 
-files_read_usr_files(wireshark_t)
 
 fs_getattr_all_fs(wireshark_t)
 fs_list_inotifyfs(wireshark_t)
@@ -90,31 +89,15 @@ fs_search_auto_mountpoints(wireshark_t)
 
 auth_use_nsswitch(wireshark_t)
 
-libs_read_lib_files(wireshark_t)
-
 miscfiles_read_fonts(wireshark_t)
-miscfiles_read_localization(wireshark_t)
 
 userdom_use_user_terminals(wireshark_t)
 
 userdom_manage_user_home_content_files(wireshark_t)
-userdom_user_home_dir_filetrans_user_home_content(wireshark_t, file)
 
-tunable_policy(`use_nfs_home_dirs',`
-	fs_manage_nfs_dirs(wireshark_t)
-	fs_manage_nfs_files(wireshark_t)
-	fs_manage_nfs_symlinks(wireshark_t)
-')
-
-tunable_policy(`use_samba_home_dirs',`
-	fs_manage_cifs_dirs(wireshark_t)
-	fs_manage_cifs_files(wireshark_t)
-	fs_manage_cifs_symlinks(wireshark_t)
-')
+userdom_filetrans_home_content(wireshark_t)
 
-optional_policy(`
-	seutil_use_newrole_fds(wireshark_t)
-')
+userdom_home_manager(wireshark_t)
 
 optional_policy(`
 	userhelper_use_fd(wireshark_t)
Index: serefpolicy-contrib-20140730/wm.if
===================================================================
--- serefpolicy-contrib-20140730.orig/wm.if
+++ serefpolicy-contrib-20140730/wm.if
@@ -1,4 +1,4 @@
-## <summary>X Window Managers.</summary>
+## <summary>X Window Managers</summary>
 
 #######################################
 ## <summary>
@@ -29,69 +29,59 @@
 #
 template(`wm_role_template',`
 	gen_require(`
-		attribute wm_domain;
 		type wm_exec_t;
+		class dbus send_msg;
+		attribute wm_domain;
 	')
 
-	########################################
-	#
-	# Declarations
-	#
-
 	type $1_wm_t, wm_domain;
-	userdom_user_application_domain($1_wm_t, wm_exec_t)
+	domain_type($1_wm_t)
+	domain_entry_file($1_wm_t, wm_exec_t)
 	role $2 types $1_wm_t;
 
-	########################################
-	#
-	# Policy
-	#
-
 	allow $1_wm_t $3:unix_stream_socket connectto;
 	allow $3 $1_wm_t:unix_stream_socket connectto;
+	allow $3 $1_wm_t:process { signal sigchld signull };
+	allow $1_wm_t $3:process { signull sigkill };
 
-	allow $3 $1_wm_t:process { ptrace signal_perms };
-	ps_process_pattern($3, $1_wm_t)
+	allow $1_wm_t $3:dbus send_msg;
+	allow $3 $1_wm_t:dbus send_msg;
 
-	allow $1_wm_t $3:process { signull sigkill };
+	userdom_manage_home_role($2, $1_wm_t)
+	userdom_manage_tmpfs_role($2, $1_wm_t)
+	userdom_manage_tmp_role($2, $1_wm_t)
+	userdom_exec_user_tmp_files($1_wm_t)
 
 	domtrans_pattern($3, wm_exec_t, $1_wm_t)
 
 	corecmd_bin_domtrans($1_wm_t, $3)
 	corecmd_shell_domtrans($1_wm_t, $3)
 
+	auth_use_nsswitch($1_wm_t)
+
+	kernel_read_system_state($1_wm_t)
+
+	auth_use_nsswitch($1_wm_t)
+
 	mls_file_read_all_levels($1_wm_t)
 	mls_file_write_all_levels($1_wm_t)
 	mls_xwin_read_all_levels($1_wm_t)
 	mls_xwin_write_all_levels($1_wm_t)
 	mls_fd_use_all_levels($1_wm_t)
 
-	auth_use_nsswitch($1_wm_t)
-
-	xserver_role($2, $1_wm_t)
-	xserver_manage_core_devices($1_wm_t)
-
-	optional_policy(`
-		dbus_spec_session_bus_client($1, $1_wm_t)
-		dbus_system_bus_client($1_wm_t)
-
-		optional_policy(`
-			wm_dbus_chat($1, $3)
-		')
-	')
-
 	optional_policy(`
-		gnome_stream_connect_gkeyringd($1, $1_wm_t)
+		pulseaudio_run($1_wm_t, $2)
 	')
 
 	optional_policy(`
-		pulseaudio_run($1_wm_t, $2)
+		xserver_role($2, $1_wm_t)
+		xserver_manage_core_devices($1_wm_t)
 	')
 ')
 
 ########################################
 ## <summary>
-##	Execute wm in the caller domain.
+##	Execute the wm program in the wm domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -104,33 +94,5 @@ interface(`wm_exec',`
 		type wm_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	can_exec($1, wm_exec_t)
 ')
-
-########################################
-## <summary>
-##	Send and receive messages from
-##	specified wm over dbus.
-## </summary>
-## <param name="role_prefix">
-##	<summary>
-##	The prefix of the user domain (e.g., user
-##	is the prefix for user_t).
-##	</summary>
-## </param>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-#
-interface(`wm_dbus_chat',`
-	gen_require(`
-		type $1_wm_t;
-		class dbus send_msg;
-	')
-
-	allow $2 $1_wm_t:dbus send_msg;
-	allow $1_wm_t $2:dbus send_msg;
-')
Index: serefpolicy-contrib-20140730/wm.te
===================================================================
--- serefpolicy-contrib-20140730.orig/wm.te
+++ serefpolicy-contrib-20140730/wm.te
@@ -1,12 +1,12 @@
-policy_module(wm, 1.4.0)
+policy_module(wm, 1.3.3)
+
+attribute wm_domain;
 
 ########################################
 #
 # Declarations
 #
 
-attribute wm_domain;
-
 type wm_exec_t;
 corecmd_executable_file(wm_exec_t)
 
@@ -18,11 +18,11 @@ corecmd_executable_file(wm_exec_t)
 allow wm_domain self:fifo_file rw_fifo_file_perms;
 allow wm_domain self:process { setcap setrlimit execmem signal_perms getsched setsched };
 allow wm_domain self:netlink_kobject_uevent_socket create_socket_perms;
+
 allow wm_domain self:shm create_shm_perms;
 allow wm_domain self:unix_dgram_socket create_socket_perms;
 
-kernel_read_system_state(wm_domain)
-
+corecmd_dontaudit_access_all_executables(wm_domain)
 corecmd_getattr_all_executables(wm_domain)
 
 dev_read_sound(wm_domain)
@@ -31,12 +31,18 @@ dev_read_urand(wm_domain)
 dev_rw_wireless(wm_domain)
 dev_write_sound(wm_domain)
 
-files_read_usr_files(wm_domain)
-
 fs_getattr_all_fs(wm_domain)
 
+application_signull(wm_domain)
+
+init_read_state(wm_domain)
+
 miscfiles_read_fonts(wm_domain)
-miscfiles_read_localization(wm_domain)
+
+systemd_dbus_chat_logind(wm_domain)
+systemd_read_logind_sessions_files(wm_domain)
+systemd_write_inhibit_pipes(wm_domain)
+systemd_login_read_pid_files(wm_domain)
 
 userdom_manage_user_tmp_sockets(wm_domain)
 userdom_tmp_filetrans_user_tmp(wm_domain, sock_file)
@@ -45,30 +51,48 @@ userdom_manage_user_home_content_dirs(wm
 userdom_manage_user_home_content_files(wm_domain)
 userdom_user_home_dir_filetrans_user_home_content(wm_domain, { dir file })
 
-optional_policy(`
-	accountsd_dbus_chat(wm_domain)
-')
-	
-optional_policy(`
-	bluetooth_dbus_chat(wm_domain)
-')		
+udev_read_pid_files(wm_domain)
 
 optional_policy(`
-	devicekit_dbus_chat_power(wm_domain)
+	gnome_stream_connect_gkeyringd(wm_domain)
 ')
 
 optional_policy(`
-	networkmanager_dbus_chat(wm_domain)
+	dbus_system_bus_client(wm_domain)
+	dbus_session_bus_client(wm_domain)
+	optional_policy(`
+		accountsd_dbus_chat(wm_domain)
+	')
+	
+	optional_policy(`
+		bluetooth_dbus_chat(wm_domain)
+	')		
+
+	optional_policy(`
+		devicekit_dbus_chat_power(wm_domain)
+	')
+
+	optional_policy(`
+		networkmanager_dbus_chat(wm_domain)
+	')
+
+	optional_policy(`
+		policykit_dbus_chat(wm_domain)
+	')
+
+	optional_policy(`
+		systemd_dbus_chat_logind(wm_domain)
+	')
 ')
 
 optional_policy(`
-	policykit_dbus_chat(wm_domain)
+	pulseaudio_stream_connect(wm_domain)
 ')
 
 optional_policy(`
-	pulseaudio_stream_connect(wm_domain)
+	userhelper_exec_consolehelper(wm_domain)
 ')
 
 optional_policy(`
-	userhelper_exec_consolehelper(wm_domain)
+	xserver_manage_core_devices(wm_domain)
 ')
Index: serefpolicy-contrib-20140730/xen.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/xen.fc
+++ serefpolicy-contrib-20140730/xen.fc
@@ -1,38 +1,42 @@
 /dev/xen/tapctrl.*	-p	gen_context(system_u:object_r:xenctl_t,s0)
 
-/usr/lib/xen-[^/]*/bin/xenconsoled	--	gen_context(system_u:object_r:xenconsoled_exec_t,s0)
-/usr/lib/xen-[^/]*/bin/xend	--	gen_context(system_u:object_r:xend_exec_t,s0)
-/usr/lib/xen-[^/]*/bin/xenstored	--	gen_context(system_u:object_r:xenstored_exec_t,s0)
-/usr/lib/xen-[^/]*/bin/xl	--	gen_context(system_u:object_r:xm_exec_t,s0)
-/usr/lib/xen-[^/]*/bin/xm	--	gen_context(system_u:object_r:xm_exec_t,s0)
-
 /usr/sbin/blktapctrl	--	gen_context(system_u:object_r:blktap_exec_t,s0)
 /usr/sbin/evtchnd	--	gen_context(system_u:object_r:evtchnd_exec_t,s0)
 /usr/sbin/tapdisk	--	gen_context(system_u:object_r:blktap_exec_t,s0)
+
+#/usr/lib/xen/bin/qemu-dm	-- gen_context(system_u:object_r:qemu_dm_exec_t,s0)
+
+ifdef(`distro_debian',`
+/usr/lib/xen-[^/]*/bin/xenconsoled -- gen_context(system_u:object_r:xenconsoled_exec_t,s0)
+/usr/lib/xen-[^/]*/bin/xend --	gen_context(system_u:object_r:xend_exec_t,s0)
+/usr/lib/xen-[^/]*/bin/xenstored -- gen_context(system_u:object_r:xenstored_exec_t,s0)
+/usr/lib/xen-[^/]*/bin/xm --	gen_context(system_u:object_r:xm_exec_t,s0)
+',`
 /usr/sbin/xenconsoled	--	gen_context(system_u:object_r:xenconsoled_exec_t,s0)
-/usr/sbin/xend	--	gen_context(system_u:object_r:xend_exec_t,s0)
+/usr/sbin/xend		--	gen_context(system_u:object_r:xend_exec_t,s0)
 /usr/sbin/xenstored	--	gen_context(system_u:object_r:xenstored_exec_t,s0)
-/usr/sbin/xl	--	gen_context(system_u:object_r:xm_exec_t,s0)
-/usr/sbin/xm	--	gen_context(system_u:object_r:xm_exec_t,s0)
+/usr/sbin/oxenstored	--	gen_context(system_u:object_r:xenstored_exec_t,s0)
+')
 
-/var/lib/xen(/.*)?	gen_context(system_u:object_r:xend_var_lib_t,s0)
+/var/lib/xen(/.*)?		gen_context(system_u:object_r:xend_var_lib_t,s0)
 /var/lib/xen/images(/.*)?	gen_context(system_u:object_r:xen_image_t,s0)
-/var/lib/xend(/.*)?	gen_context(system_u:object_r:xend_var_lib_t,s0)
+/var/lib/xend(/.*)?		gen_context(system_u:object_r:xend_var_lib_t,s0)
 /var/lib/xenstored(/.*)?	gen_context(system_u:object_r:xenstored_var_lib_t,s0)
 
 /var/log/evtchnd\.log.*	--	gen_context(system_u:object_r:evtchnd_var_log_t,s0)
-/var/log/xen(/.*)?	gen_context(system_u:object_r:xend_var_log_t,s0)
+/var/log/xen(/.*)?		gen_context(system_u:object_r:xend_var_log_t,s0)
 /var/log/xen-hotplug\.log.*	--	gen_context(system_u:object_r:xend_var_log_t,s0)
 /var/log/xend\.log.*	--	gen_context(system_u:object_r:xend_var_log_t,s0)
 /var/log/xend-debug\.log.*	--	gen_context(system_u:object_r:xend_var_log_t,s0)
+/var/log/xenstored.*		gen_context(system_u:object_r:xenstored_var_log_t,s0)
 
 /var/run/evtchnd	-s	gen_context(system_u:object_r:evtchnd_var_run_t,s0)
 /var/run/evtchnd\.pid	--	gen_context(system_u:object_r:evtchnd_var_run_t,s0)
-/var/run/xenconsoled\.pid	--	gen_context(system_u:object_r:xenconsoled_var_run_t,s0)
-/var/run/xend(/.*)?	gen_context(system_u:object_r:xend_var_run_t,s0)
+/var/run/xenconsoled\.pid --	gen_context(system_u:object_r:xenconsoled_var_run_t,s0)
+/var/run/xend(/.*)?		gen_context(system_u:object_r:xend_var_run_t,s0)
 /var/run/xend\.pid	--	gen_context(system_u:object_r:xend_var_run_t,s0)
-/var/run/xenner(/.*)?	gen_context(system_u:object_r:xend_var_run_t,s0)
+/var/run/xenner(/.*)?		gen_context(system_u:object_r:xend_var_run_t,s0)
 /var/run/xenstore\.pid	--	gen_context(system_u:object_r:xenstored_var_run_t,s0)
 /var/run/xenstored(/.*)?	gen_context(system_u:object_r:xenstored_var_run_t,s0)
 
-/xen(/.*)?	gen_context(system_u:object_r:xen_image_t,s0)
+/xen(/.*)?			gen_context(system_u:object_r:xen_image_t,s0)
Index: serefpolicy-contrib-20140730/xen.if
===================================================================
--- serefpolicy-contrib-20140730.orig/xen.if
+++ serefpolicy-contrib-20140730/xen.if
@@ -1,13 +1,13 @@
-## <summary>Xen hypervisor.</summary>
+## <summary>Xen hypervisor</summary>
 
 ########################################
 ## <summary>
 ##	Execute a domain transition to run xend.
 ## </summary>
 ## <param name="domain">
-##	<summary>
+## 	<summary>
 ##	Domain allowed to transition.
-##	</summary>
+## 	</summary>
 ## </param>
 #
 interface(`xen_domtrans',`
@@ -15,18 +15,18 @@ interface(`xen_domtrans',`
 		type xend_t, xend_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, xend_exec_t, xend_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute xend in the caller domain.
+##	Allow the specified domain to execute xend
+##	in the caller domain.
 ## </summary>
 ## <param name="domain">
-##	<summary>
+## 	<summary>
 ##	Domain allowed access.
-##	</summary>
+## 	</summary>
 ## </param>
 #
 interface(`xen_exec',`
@@ -34,7 +34,6 @@ interface(`xen_exec',`
 		type xend_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	can_exec($1, xend_exec_t)
 ')
 
@@ -75,24 +74,43 @@ interface(`xen_dontaudit_use_fds',`
 	dontaudit $1 xend_t:fd use;
 ')
 
+#######################################
+## <summary>
+##  Read xend pid files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`xen_read_pid_files_xenstored',`
+    gen_require(`
+        type xenstored_var_run_t;
+    ')
+
+    files_search_pids($1)
+
+    read_files_pattern($1, xenstored_var_run_t, xenstored_var_run_t)
+')
+
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	xend image directories.
+##	Read xend lib files.
 ## </summary>
 ## <param name="domain">
-##	<summary>
+## 	<summary>
 ##	Domain allowed access.
-##	</summary>
+## 	</summary>
 ## </param>
 #
-interface(`xen_manage_image_dirs',`
+interface(`xen_read_lib_files',`
 	gen_require(`
 		type xend_var_lib_t;
 	')
 
-	files_search_var_lib($1)
-	manage_dirs_pattern($1, xend_var_lib_t, xend_var_lib_t)
+	files_list_var_lib($1)
+	read_files_pattern($1, xend_var_lib_t, xend_var_lib_t)
 ')
 
 ########################################
@@ -100,9 +118,9 @@ interface(`xen_manage_image_dirs',`
 ##	Read xend image files.
 ## </summary>
 ## <param name="domain">
-##	<summary>
+## 	<summary>
 ##	Domain allowed access.
-##	</summary>
+## 	</summary>
 ## </param>
 #
 interface(`xen_read_image_files',`
@@ -111,18 +129,40 @@ interface(`xen_read_image_files',`
 	')
 
 	files_list_var_lib($1)
+
 	list_dirs_pattern($1, xend_var_lib_t, xend_var_lib_t)
 	read_files_pattern($1, { xend_var_lib_t xen_image_t }, xen_image_t)
 ')
 
 ########################################
 ## <summary>
-##	Read and write xend image files.
+##	Allow the specified domain to read/write
+##	xend image files.
 ## </summary>
 ## <param name="domain">
-##	<summary>
+## 	<summary>
 ##	Domain allowed access.
-##	</summary>
+## 	</summary>
+## </param>
+#
+interface(`xen_manage_image_dirs',`
+	gen_require(`
+		type xend_var_lib_t;
+	')
+
+	files_list_var_lib($1)
+	manage_dirs_pattern($1, xend_var_lib_t, xend_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Allow the specified domain to read/write
+##	xend image files.
+## </summary>
+## <param name="domain">
+## 	<summary>
+##	Domain allowed to transition.
+## 	</summary>
 ## </param>
 #
 interface(`xen_rw_image_files',`
@@ -137,7 +177,8 @@ interface(`xen_rw_image_files',`
 
 ########################################
 ## <summary>
-##	Append xend log files.
+##	Allow the specified domain to append
+##	xend log files.
 ## </summary>
 ## <param name="domain">
 ## 	<summary>
@@ -157,13 +198,13 @@ interface(`xen_append_log',`
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
+##	Create, read, write, and delete the
 ##	xend log files.
 ## </summary>
 ## <param name="domain">
-##	<summary>
+## 	<summary>
 ##	Domain allowed access.
-##	</summary>
+## 	</summary>
 ## </param>
 #
 interface(`xen_manage_log',`
@@ -176,29 +217,11 @@ interface(`xen_manage_log',`
 	manage_files_pattern($1, xend_var_log_t, xend_var_log_t)
 ')
 
-#######################################
-## <summary>
-##	Read xenstored pid files.
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-#
-interface(`xen_read_xenstored_pid_files',`
-	gen_require(`
-		type xenstored_var_run_t;
-	')
-
-	files_search_pids($1)
-	read_files_pattern($1, xenstored_var_run_t, xenstored_var_run_t)
-')
-
 ########################################
 ## <summary>
 ##	Do not audit attempts to read and write
-##	Xen unix domain stream sockets.
+##	Xen unix domain stream sockets.  These
+##	are leaked file descriptors.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -216,8 +239,7 @@ interface(`xen_dontaudit_rw_unix_stream_
 
 ########################################
 ## <summary>
-##	Connect to xenstored with a unix
-##	domain stream socket.
+##	Connect to xenstored over a unix stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -236,8 +258,7 @@ interface(`xen_stream_connect_xenstore',
 
 ########################################
 ## <summary>
-##	Connect to xend with a unix
-##	domain stream socket.
+##	Connect to xend over a unix domain stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -270,16 +291,15 @@ interface(`xen_stream_connect',`
 interface(`xen_domtrans_xm',`
 	gen_require(`
 		type xm_t, xm_exec_t;
+		attribute virsh_transition_domain;
 	')
-
-	corecmd_search_bin($1)
+	typeattribute $1 virsh_transition_domain;
 	domtrans_pattern($1, xm_exec_t, xm_t)
 ')
 
 ########################################
 ## <summary>
-##	Connect to xm with a unix
-##	domain stream socket.
+##	Connect to xm over a unix stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -289,7 +309,7 @@ interface(`xen_domtrans_xm',`
 #
 interface(`xen_stream_connect_xm',`
 	gen_require(`
-		type xm_t;
+		type xm_t, xenstored_var_run_t;
 	')
 
 	files_search_pids($1)
